import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, extendIgnoreDataRule, setDataFieldValue, showApprove, guid, initQueryFilter, ShowDateTime, ShowPrintClose, showFiles } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class DM008ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'none' },
            formCode: 'PF123',
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    loadData = (id) => {
        var isCheck = (this.props.data.tableKey != undefined && this.props.data.tableKey == '1') ? true : false
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_Category')
        extendInclude(json, 'Nav_DeviceBase')
        extendInclude(json, 'Nav_ListUser.Nav_User')
        extendInclude(json, 'Nav_FilesPlan.Nav_ImgFile.Nav_File')
        extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File')
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'DM/DeviceMaintenancePlan/Get',
            onComplete: (ret) => {
                if (ret) {
                    this.setState({
                        data: ret,
                        isCheck: isCheck
                    })
                }
            }
        });
    }
    sign = () => {
        let json = initFilter(this.props.login.OrgId, this.props.data.id, null, null, null, this.props.data.TaskID);
        extendRule(json, 'ID', 1, this.props.data.id);
        extendRule(json, 'Parameter1', 1, this.props.data.TaskID)
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'DM/DMDeviceMaintenancePlan/Check',
            onComplete: (ret) => {
                ShowPrintClose(this.props)
            }
        });
    }
    render() {
        const { data, isCheck } = this.state;
        const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        <td><Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon='export'>审批详情</Button></td>
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} pageStyle={"#tableId" + this.props.data.id + " { padding:0 40px;} img{width :120px}"} /></td>
                        <td><ExportToExcel fileName='设备设施维保计划' tableId={'tableId' + this.props.data.id} /></td>
                        {isCheck ? <td><Button type={'primary'} icon={'check'} onClick={() => this.sign()} >确认</Button>  </td> : null}
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px', paddingTop: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>设备设施维保计划</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="年度">{data.YEARPLAN}</Descriptions.Item>
                            <Descriptions.Item label="维保人员">{data.Nav_ListUser?.map((item, i) => {
                                return <a style={{ color: item.ISCHECK == false ? "red" : "#000000A6" }}> {(i > 0 ? "，" : "") + item.Nav_User.NAME}</a>
                            })}</Descriptions.Item>
                            <Descriptions.Item label="系统分类">{data.Nav_Category.NAME}</Descriptions.Item>
                            <Descriptions.Item label="设备设施库">{data.Nav_DeviceBase.NAME}</Descriptions.Item>
                            <Descriptions.Item label="规格">{data.SPEC}</Descriptions.Item>
                            <Descriptions.Item label="数量">{data.COUNT}</Descriptions.Item>
                            <Descriptions.Item label="位置">{data.POSITION}</Descriptions.Item>
                            <Descriptions.Item label="维保内容">{data.CONTENT}</Descriptions.Item>
                            <Descriptions.Item label="触发频率">{enums.BSPLANCHECKFREQUENCYEnum.enums[data.PLANCHECKFREQUENCY]}</Descriptions.Item>
                            {/* <Descriptions.Item label="触发日期">{data.RUNDATA}</Descriptions.Item> */}

                            {data.PLANCHECKFREQUENCY > 20 ? <Descriptions.Item label="日">{data.DATA}</Descriptions.Item> : null}
                            {data.PLANCHECKFREQUENCY == 60 ? <Descriptions.Item label="触发日期">{data.RUNDATA}</Descriptions.Item> : null}
                            {data.PLANCHECKFREQUENCY == 20 ? <Descriptions.Item label="星期">{enums.WEEKDATAEnum.enums[data.WEEKDATA]}</Descriptions.Item> : null}

                            <Descriptions.Item label="触发时间">{ShowDateTime(data.RUNSETTIME, "HH:mm")}</Descriptions.Item>
                            <Descriptions.Item label="维修计划">{showFiles(data.Nav_FilesPlan, config.picServerHost)}</Descriptions.Item>
                            <Descriptions.Item label="维保工作方案">{showFiles(data.Nav_Files, config.picServerHost)}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
            </div>
        </div>
    }
}
export default connect(({ login, app }) => ({ login, app }))(DM008ShowPrint) 
